import { Constructor, AbstractType } from '@dao-xyz/borsh';
import { IPFS } from 'ipfs-core-types';
export interface Manifest {
    data: Uint8Array;
}
export interface Addressable {
    get name(): string;
    get address(): Address | undefined;
}
export declare class Address {
    cid: string;
    constructor(cid: string);
    toString(): string;
    equals(other: Address): boolean;
    static isValid(oaddress: {
        toString(): string;
    }): boolean;
    static parse(oaddress: {
        toString(): string;
    }): Address;
    static join(cid: string): string;
}
export declare const save: (ipfs: IPFS, thing: Addressable, options?: {
    format?: string;
    pin?: boolean;
    timeout?: number;
}) => Promise<Address>;
export declare const load: <S extends Addressable & {
    address: Address;
}>(ipfs: IPFS, address: Address, into: Constructor<S> | AbstractType<S>, options?: {
    timeout?: number;
}) => Promise<S>;
